function [wvect] = PickWeights(num, summ)
%Returns num synaptic weights, randomly chosen, that add up to summ.

wvect = zeros(num, 1);

%first check if the request is possible
if summ > num
    error('Impossible to make all weights less than or equal to one');
end;

if mod(num, 1) ~= 0
    error('Number of weights must be an integer');
end;

%second, determine weights so that none are greater than one
tot = 0;
for i=1:num
    %find range that number will be chosen from
    lowerb = (summ - tot) - (num - (i));
    if lowerb < 0
        lowerb = 0;
    end
    if summ - tot > 1
        upperb = 1;
    else
        upperb = summ - tot;
    end
    if i == num
        wvect(i) = lowerb;
    else
        wvect(i) = lowerb + (rand * (upperb - lowerb));
        tot = tot + wvect(i);
    end
    
end


    
    


