function varargout = CollectiveExcitationsGUI(varargin)
% For Natal Physics and Neuroscience workshop, August, 2014. By John Beggs
% COLLECTIVEEXCITATIONSGUI M-file for CollectiveExcitationsGUI.fig
%      COLLECTIVEEXCITATIONSGUI, by itself, creates a new COLLECTIVEEXCITATIONSGUI or raises the existing
%      singleton*.
%
%      H = COLLECTIVEEXCITATIONSGUI returns the handle to a new COLLECTIVEEXCITATIONSGUI or the handle to
%      the existing singleton*.
%
%      COLLECTIVEEXCITATIONSGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in COLLECTIVEEXCITATIONSGUI.M with the given input arguments.
%
%      COLLECTIVEEXCITATIONSGUI('Property','Value',...) creates a new COLLECTIVEEXCITATIONSGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before NetworkGUItest2_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to CollectiveExcitationsGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES



% Edit the above text to modify the response to help CollectiveExcitationsGUI

% Last Modified by GUIDE v2.5 11-Aug-2014 17:46:28

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @CollectiveExcitationsGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @CollectiveExcitationsGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before CollectiveExcitationsGUI is made visible.
function CollectiveExcitationsGUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to CollectiveExcitationsGUI (see VARARGIN)
set(hObject, 'toolbar', 'figure');

% Choose default command line output for CollectiveExcitationsGUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes CollectiveExcitationsGUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = CollectiveExcitationsGUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in play.
function play_Callback(hObject, eventdata, handles)
% hObject    handle to play (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
r = 21;
c = 21;

Num = get(handles.select_neighbor, 'String');
N = str2num(Num);
Neighbor = N;

if Neighbor == 1
    Num = get(handles.max_dist, 'String');
    N = str2num(Num);
    mD = N;
    WM = zeros(r*c, r*c); 
    for i=1:r*c
        for j=1:r*c
            [x1 y1] = Linear2Cartesian(i,r);
            [x2 y2] = Linear2Cartesian(j,r);
            if  sqrt((x2-x1)^2 + (y2-y1)^2)<= mD 
                WM(i,j) = 1;
            end
        end
    end
    %here keep only conn_density of the nearest neighbor connections,
    %removing the rest
    Num = get(handles.conn_density, 'String');
    N = str2num(Num);
    cD = N;
    occupied = find(WM == 1);
    WM(occupied) = 0;
    occupiedScrambled = randperm(length(occupied));
    endpoint = min(floor(length(occupied)* cD)+1 , length(occupied));
    toKeep = occupiedScrambled(1:endpoint);
    K = occupied(toKeep);
    WM(K) = 1;
    
else
    Num = get(handles.conn_density, 'String');
    N = str2num(Num);
    cD = N;
    J = rand(r*c*r*c, 1); 
    K = find(J < cD); 
    WM = zeros(r*c, r*c);
    WM(K) = 1;

end

timesteps = 100;
Num = get(handles.ref_period, 'String');
N = str2num(Num);
refperiod = N;  %number of time steps that unit is refractory after firing


%initialize matricies
spont = sparse(r*c,1);  %random "membrane potentials" between 0 and 1 for each unit
ref = sparse(r*c,1);  %lists how many time steps each electrode will be refractory for
act = sparse(r*c,1);  %gives driven activity at each unit, set by spont and connectivity matrix
act2 = sparse(r*c,1);
current = sparse(r*c,1); %status of activity at current time step 
next = sparse(r*c,1);  %status of activity at next time step
WMA = sparse(r*c, r*c); %Weight matrix active (those weights chosen by chance to be "active" during that time step
TIMERASTER = sparse(r*c, timesteps);  %stores times of events for plotting later using LFPsorter routines

Num = get(handles.neuron_thresh, 'String');
N = str2num(Num);
Nthresh = N;

Num = get(handles.prob_spont, 'String');
N = str2num(Num);
p = N;  %probability of spontaneous activity at a single unit


%march through time steps
for i=1:timesteps

   %determine spontaneous activity over threshold
   holder = find(rand(r*c,1) < p);
   spont(holder) = 1;
      
   %determine units to be activated next time step by current activtiy that is over threshold
   J = find(rand(r*c, r*c) < WM); %first find connections that could be active
   WMA(J) = 1;
   act = WMA * current;  
   J = find(act >= Nthresh); 
   act = sparse(r*c, 1);
   act(J) = 1;
   
   
   
   %determine activity at next time step
   next = spont + act;
   holder = find(ref > 0);  %turn off all units that are already refractory
   next(holder) = 0;
   holder = find(current >= 1);
   next(holder) = 0;        %turn off all units in next time step that fired in current time step
   holder = find(next >= 1);
   next(holder) = 1;        %make next have binary values only
   holder = find(next < 1);
   next(holder) = 0;
   
   %determine refractory units for next time step
   ref = ref -1;  %decrement old values
   holder = find(ref < 0);
   ref(holder) = 0;
   holder = find(next >= 1);  %increment new values
   ref(holder) = refperiod;
      
   %update current matrix and clear other matricies
   current = next;
   next = sparse(r*c,1);
   act = sparse(r*c,1);
   spont = sparse(r*c,1);
   WMA = sparse(r*c, r*c);
   TIMERASTER(:, i) = current;
   
end;

%watch it
startind = 1; %this is the index of the first frame you will view
Holder = sum(TIMERASTER);
J = find(Holder);

framenum = length(J); %number of time steps you want to look at
frames = framenum;
axis equal
M = moviein(frames);
PMATRIX = [];
set(gca,'NextPlot','replacechildren')
axes(handles.axes1);
for i=1:framenum
    spy4(reshape(10*TIMERASTER(:,J(i)), r, c)); 
    grid off
    M(:,i) = getframe;
    guidata(hObject, handles);
end;

guidata(hObject, handles);

save NetMovie M TIMERASTER WM K r c framenum J -mat

axes(handles.axes2);
spy2b(TIMERASTER); grid off; 
ylabel('Neuron Number'); xlabel('Time (ms)');
daspect([1 4 1]);
guidata(hObject, handles);

% --- Executes on button press in clear.
function clear_Callback(hObject, eventdata, handles)
% hObject    handle to clear (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cla(handles.axes1, 'reset');
cla(handles.axes2, 'reset');
set(handles.conn_density, 'String', '0.001');
set(handles.ref_period, 'String', '5');
set(handles.max_dist, 'String', '1.5');
set(handles.neuron_thresh, 'String', '1.5');
set(handles.prob_spont, 'String', '0.01');
guidata(hObject, handles);



% --- Executes on button press in rerun_movie.
function rerun_movie_Callback(hObject, eventdata, handles)
% hObject    handle to rerun_movie (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

load NetMovie -mat
axes(handles.axes1);
axis('square')
movie(M, 1, 7);
guidata(hObject, handles);

axes(handles.axes2);
spy2b(TIMERASTER); grid off; 
ylabel('Neuron Number'); xlabel('Time (ms)');
daspect([1 4 1]);
guidata(hObject, handles);



function conn_density_Callback(hObject, eventdata, handles)
% hObject    handle to conn_density (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of conn_density as text
%        str2double(get(hObject,'String')) returns contents of conn_density as a double
input = str2num(get(hObject, 'String'));
if (isempty(input))
    set(hObject, 'String', '0')
end
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function conn_density_CreateFcn(hObject, eventdata, handles)
% hObject    handle to conn_density (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function ref_period_Callback(hObject, eventdata, handles)
% hObject    handle to ref_period (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ref_period as text
%        str2double(get(hObject,'String')) returns contents of ref_period as a double
input = str2num(get(hObject, 'String'));
if (isempty(input))
    set(hObject, 'String', '0')
end
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function ref_period_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ref_period (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function max_dist_Callback(hObject, eventdata, handles)
% hObject    handle to max_dist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of max_dist as text
%        str2double(get(hObject,'String')) returns contents of max_dist as a double
input = str2num(get(hObject, 'String'));
if (isempty(input))
    set(hObject, 'String', '0')
end
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function max_dist_CreateFcn(hObject, eventdata, handles)
% hObject    handle to max_dist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function select_random_Callback(hObject, eventdata, handles)
% hObject    handle to select_random (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of select_random as text
%        str2double(get(hObject,'String')) returns contents of select_random as a double
input = str2num(get(hObject, 'String'));
if (isempty(input))
    set(hObject, 'String', '0')
end
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function select_random_CreateFcn(hObject, eventdata, handles)
% hObject    handle to select_random (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function select_neighbor_Callback(hObject, eventdata, handles)
% hObject    handle to select_neighbor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of select_neighbor as text
%        str2double(get(hObject,'String')) returns contents of select_neighbor as a double
input = str2num(get(hObject, 'String'));
if (isempty(input))
    set(hObject, 'String', '0')
end
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function select_neighbor_CreateFcn(hObject, eventdata, handles)
% hObject    handle to select_neighbor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function spy2b(S,arg2,arg3);
%SPY Visualize sparsity pattern.
%   SPY(S) plots the sparsity pattern of the matrix S.
%
%   SPY(S,'LineSpec') uses the color and marker from the line
%   specification string 'LineSpec' (See PLOT for possibilities).
%
%   SPY(S,markersize) uses the specified marker size instead of
%   a size which depends upon the figure size and the matrix order.
%
%   SPY(S,'LineSpec',markersize) sets both.

%   SPY(S,markersize,'LineSpec') also works.

%   Copyright (c) 1984-98 by The MathWorks, Inc.
%   $Revision: 5.12 $  $Date: 1997/11/21 23:44:52 $


cax = newplot;
next = lower(get(cax,'NextPlot'));
hold_state = ishold;

marker = ''; color = ''; markersize = 7; linestyle = 'none';
if nargin >= 2
   if isstr(arg2), 
      [line,color,marker,msg] = colstyle(arg2); error(msg)
   else,
      markersize = arg2;
   end
end
if nargin >= 3
   if isstr(arg3),
      [line,color,marker,msg] = colstyle(arg3); error(msg)
   else,
      markersize = arg3;
   end
end
if isempty(marker), marker = '.'; end    %experimental change- it can also be marker = 'o'
if isempty(color), co = get(cax,'colororder'); color = co(1,:); end

[m,n] = size(S);
if marker~='.' & markersize==0,
   markersize = get(gcf,'defaultlinemarkersize');
end
if markersize == 0
   units = get(gca,'units');
   set(gca,'units','points');
   pos = get(gca,'position');
   markersize = max(4,min(14,round(6*min(pos(3:4))/max(m+1,n+1))));
   set(gca,'units',units);
end


[i,j] = find(S);
if isempty(i), i = NaN; j = NaN; end
if isempty(S), marker = 'none'; end
plot(j,i,'marker',marker,'markersize',markersize, ...
   'linestyle',linestyle,'color',color);
%axes('square');
daspect([1 4 1]);

xlabel(['nz = ' int2str(nnz(S))]);
grid on
set(gca,'xlim',[0 n+1],'ylim',[0 m+1],'ydir','reverse', ...
   'plotboxaspectratio',[n+1 n+1 1]);
set(gcf,'renderer','painters')

if ~hold_state, set(cax,'NextPlot',next); end



function spy4(S,arg2,arg3);
%SPY Visualize sparsity pattern.
%   SPY(S) plots the sparsity pattern of the matrix S.
%
%   SPY(S,'LineSpec') uses the color and marker from the line
%   specification string 'LineSpec' (See PLOT for possibilities).
%
%   SPY(S,markersize) uses the specified marker size instead of
%   a size which depends upon the figure size and the matrix order.
%
%   SPY(S,'LineSpec',markersize) sets both.

%   SPY(S,markersize,'LineSpec') also works.

%   Copyright (c) 1984-98 by The MathWorks, Inc.
%   $Revision: 5.12 $  $Date: 1997/11/21 23:44:52 $

%declare globals
global REGION FPRASTER

cax = newplot;
next = lower(get(cax,'NextPlot'));
hold_state = ishold;

marker = ''; color = ''; markersize = 7; linestyle = 'none';
if nargin >= 2
   if isstr(arg2), 
      [line,color,marker,msg] = colstyle(arg2); error(msg)
   else,
      markersize = arg2;
   end
end
if nargin >= 3
   if isstr(arg3),
      [line,color,marker,msg] = colstyle(arg3); error(msg)
   else,
      markersize = arg3;
   end
end
if isempty(marker), marker = 'o'; end    %experimental change- it was marker = '.'
if isempty(color), co = get(cax,'colororder'); color = co(1,:); end

[m,n] = size(S);
if marker~='.' & markersize==0,
   markersize = get(gcf,'defaultlinemarkersize');
end
if markersize == 0
   units = get(gca,'units');
   set(gca,'units','points');
   pos = get(gca,'position');
   markersize = max(4,min(14,round(6*min(pos(3:4))/max(m+1,n+1))));
   set(gca,'units',units);
end


[I,J] = find(S);
if isempty(I)
   I = NaN; 
   J = NaN; 
   endrun = 0;
else
   endrun = length(I);
end;
if isempty(S), marker = 'none'; end;
cm = colormap;
for k=1:endrun  
   plot(J(k),I(k),'marker',marker,'markersize',abs(S(I(k),J(k))), ...
      'linestyle',linestyle,'MarkerFaceColor', cm(13,:));
   hold on
end;

xlabel(['nz = ' int2str(nnz(S))]);
grid on
set(gca,'xlim',[0 n+1],'ylim',[0 m+1],'ydir','reverse', ...
   'plotboxaspectratio',[n+1 n+1 1]);
set(gcf,'renderer','painters')

if ~hold_state, set(cax,'NextPlot',next); end



function [row col] = Linear2Cartesian(L, r)
%function Linear2Cartesian takes a linear matrix index L and converts it to
%a Cartesian row and column pair of indices. Also needed is the number of
%rows in the matrix, given by r. 
%see also Cartesian2Linear

col = floor((L-1)/r) + 1;
row = L - floor((L-1)/r)*r;




function neuron_thresh_Callback(hObject, eventdata, handles)
% hObject    handle to neuron_thresh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of neuron_thresh as text
%        str2double(get(hObject,'String')) returns contents of neuron_thresh as a double
input = str2num(get(hObject, 'String'));
if (isempty(input))
    set(hObject, 'String', '0')
end
guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function neuron_thresh_CreateFcn(hObject, eventdata, handles)
% hObject    handle to neuron_thresh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function prob_spont_Callback(hObject, eventdata, handles)
% hObject    handle to prob_spont (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of prob_spont as text
%        str2double(get(hObject,'String')) returns contents of prob_spont as a double
input = str2num(get(hObject, 'String'));
if (isempty(input))
    set(hObject, 'String', '0')
end
guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function prob_spont_CreateFcn(hObject, eventdata, handles)
% hObject    handle to prob_spont (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
load NetMovie -mat
%code for scrambled movie
newOrder = randperm(r*c);
axes(handles.axes1);
for i=1:framenum
    spy4(reshape(10*TIMERASTER([newOrder],J(i)), r, c)); 
    grid off
    Mscrambled(:,i) = getframe;
    guidata(hObject, handles);
end;

axes(handles.axes1);
axis('square')
%movie(Mscrambled, 1, 7);
guidata(hObject, handles);

axes(handles.axes2);
spy2b(TIMERASTER(newOrder, :)); grid off; 
ylabel('Neuron Number'); xlabel('Time (ms)');
daspect([1 4 1]);
guidata(hObject, handles); 




% --- Executes during object creation, after setting all properties.
function pushbutton5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
