function [TR] = Dissociated2TIMERASTER(data)
%Takes data sets from the DissociatedCultures data folder and extracts a
%TIMERASATER from them so that the analysis programs can be used. 

[r c] = size(data.spikes);
maxVal = 0;
for i=1:r
    if max(data.spikes{i}) > maxVal
        maxVal = max(data.spikes{i});
    end
end

%now preallocate TIMERASTER
TIMERASTER = sparse(r, maxVal);


% insert 1 at each time bin when the neuron spikes
for i = 1:r
    TIMERASTER(i, data.spikes{i}) = 1;
end

TR = TIMERASTER; 

