function VisualizeRaster(TR)
%Script to plot data in raster form. Also plots population activity over time. 
%Input is TR, which should be a TIMERASTER

%First, load a data set from one of the data folders. For example, go into
%the folder entitled "Mouse" and drop DataSet4 into the Matlab workspace.
%Alternatively, go to the Home tab in Matlab and then click on the Import
%Data button. 

%Second, if necessary, get it into TIMERASTER format
%After the data are loaded into Matlab, if there is a cell array with the
%name ASDF, then you need to convert it into TIMERASTER format by using the
%step below. If the loaded data already have a TIMERASTER variable, then
%you do not need to do this step. 
%[TIMERASTER, binunit] = ASDFToSparse(ASDF);


%Third, look at it 
figure; spy2(TR); ylabel('Neuron number', 'FontSize', 15); xlabel('Timesteps', 'FontSize', 15); 


%Fourth, plot population activity over time
figure; plot(sum(TR)); ylabel('Neurons active', 'FontSize', 15); xlabel('Timesteps', 'FontSize', 15); 

%You can use the zoom tools on the figure to look at the activity at
%different scales.
