function EntropyPlotter(Hresp, Hcond, BRs)
%Plots Hresp, Hcond against BRs

%Now for Hresp
TotalHresp = mean(Hresp, 3); %the 3 here means the 3rd dimension of this 3D array
[timesteps, ~] = size(TotalHresp); 
figure; 
plot(BRs, TotalHresp(1,:)); hold on
ylabel('Hresp (bits)', 'FontSize', 15); xlabel('Branching Ratio', 'FontSize', 15);
title('Hresp vs BR (a curve for each timestep)');
for i=2:timesteps
   plot(BRs, TotalHresp(i,:)); hold on 
end
ylim([0 max(max(max(Hresp)))]); %keep same y-axis scale for these plots

%Now for Hcond
TotalHcond = mean(Hcond, 3); %the 3 here means the 3rd dimension of this 3D array
figure; 
plot(BRs, TotalHcond(1,:)); hold on
ylabel('Hcond (bits)', 'FontSize', 15); xlabel('Branching Ratio', 'FontSize', 15);
title('Hcond vs BR (a curve for each timestep)');
for i=2:timesteps
   plot(BRs, TotalHcond(i,:)); hold on 
end
ylim([0 max(max(max(Hresp)))]); %keep same y-axis scale for these plots

%Check: MI as the difference between Hresp and Hcond
figure; 
plot(BRs, (TotalHresp(1,:) -TotalHcond(1,:))); hold on
ylabel('Hresp - Hcond (bits)', 'FontSize', 15); xlabel('Branching Ratio', 'FontSize', 15);
title('Hresp - Hcond vs BR (a curve for each timestep)');
for i=2:timesteps
   plot(BRs, (TotalHresp(i,:) - TotalHcond(i,:))); hold on 
end
ylim([0 max(max(max(Hresp)))]); %keep same y-axis scale for these plots
