function InfoVsTime(TotalMI, BRs)
%plots MI vs time
%Uses output from RecurrentInfoFunction TotalMI and BRs

%Assign variables
TotalMIavg = mean(TotalMI, 3); 
[timesteps, ~] = size(TotalMIavg);
increment = BRs(2) - BRs(1);
increments = length(BRs);
BR_Start = BRs(1); 

%Plot how MI falls off with timesteps. Each BR plot has a different color.
figure; plot(TotalMIavg); ylabel('Mutual Information (bits)', 'FontSize', 15); xlabel('Timesteps', 'FontSize', 15);
title('MI vs time for different BR')
upperLim = max(max(TotalMIavg));
ylim([0 upperLim]);

%Now plot MI vs timestep for each BR in loglog coordinates
for i=1:increments
    BR = BR_Start + (i-1)*increment;
    figure; loglog([1:length(TotalMIavg(:,i))], TotalMIavg(:,i));
    ylabel('Log10(MI) (bits)', 'FontSize', 15); xlabel('Log10(timesteps)', 'FontSize', 15);
    title(['Branching Ratio = ' num2str(BR)]);
    xlim([1 timesteps]);   %keep same x-axis scale for these plots
    ylim([1e-3 upperLim]); %keep same y-axis scale for these plots
end