function RecurrentMIplotter(TotalMI, BRs)
%plots output from RecurrentInfoFunction 
%Specifically, plots MI vs BR when given TotalMI and BRs

[l, w, n] = size(TotalMI);
timesteps = l;
TotalMIavg = mean(TotalMI, 3); %the 3 here means the 3rd dimension of this 3D array. Averaging over all networks.
figure; 
plot(BRs, TotalMIavg(1,:)); hold on  %plot MI vs BR for first timestep
for i=2:timesteps
   plot(BRs, TotalMIavg(i,:)); hold on %now plot for every other timestep, each in a different color. It shrinks with time.
end
ylabel('Mutual Information (bits)', 'FontSize', 15); xlabel('Branching Ratio', 'FontSize', 15);
title('Mutual info vs BR, for each timestep');