function BRplotter(TIMERASTER)
%Given a TIMERASTER, plots branching ratio estimates taken every 10 seconds 
%Also roduces a histogram of BR values
%calls branchingEstimate, histogram

%Sample TIMERASTER every 10 seconds, get BR for each sample
[r, c] = size(TIMERASTER);
BRestimates = zeros(1, floor(c/10000)); 
count = 1; 
for i=1:10000:c-10000
    count
    BRestimates(count) = branchingEstimate(TIMERASTER(:, i:i+10000)); 
    count = count + 1;
end

%Plot BR over time
figure; plot(BRestimates, 'o'); ylabel('BR estimates', 'FontSize', 15); xlabel('Time in 10 sec segments', 'FontSize', 15);

%Get a histogram of BR values
figure; histogram(BRestimates);
ylabel('Counts', 'FontSize', 15); xlabel('BR estimate', 'FontSize', 15);

