function [CCS, CCD ] = GetCCDFs(S, D)
%Using avalanche size distribution (S) duration distribution (D), 
% produced by the AvalancheAnalysis function, this 
% function produces complementary cumulative distribution 
% functions for each: CCS, CCD. It also plots the CCDFs for each. Note that
% S and D are both outputs of the function AvalancheAnalysis.


%%First get CCDF from avalanche duration distribution
%Get cumulative plot
Duration = D(2,:);    
Z = cumsum(Duration);
y = 1:length(Z);
clear Duration
Y = 1-Z; %For plotting cumulative complementary distribution function (CCDF)
CCD = Y;
% figure; loglog(1-Z);
figure; plot(log10(y), log10(Y));  title('CCDF of Avalanche durations', 'Fontsize', 15); ylabel('Log(CCDF of Avalanche durations)', 'FontSize', 15); xlabel('Log(Avalanche duration)', 'FontSize', 15);
%ylim([-4 0]);



%%Second get CCDF from avalanche size distribution
clear y Y Z
Sizes = S(2,:);
Z = cumsum(Sizes);
y = 1:length(Z);
Y = 1 - Z; %For plotting cumulative complementary distribution function (CCDF)
CCS = Y;
figure; plot(log10(y), log10(Y));  title('CCDF of Avalanche sizes', 'Fontsize', 15); ylabel('Log(CCDF of Avalanche sizes)', 'FontSize', 15); xlabel('Log(Avalanche size)', 'FontSize', 15);
%ylim([-4 0]);

