function NumNeuronsOverTime(TIMERASTER, Window)
%Breaks a TIMERASTER into segments of Window time bins and counts the
%number of neurons that were active in each Window

%Get TIMERASTER from data using the functions below
% [TIMERASTER, binunit] = ASDFToSparse(ASDF);  %if you are using
% organotypic culture data
% [TIMERASTER] = Dissociated2TIMERASTER(data); %if you are using
% dissociated culture data

%Sample TIMERASTER every, say, 10 seconds and get the number of neurons active for each sample
%Window tells how many time bins will be used from the TIMERASTER
[r, c] = size(TIMERASTER);
NumNeurons = zeros(1, floor(c/Window)); 
count = 1; 
for i=1:Window:c-Window
    count
    Y = sum(TIMERASTER(:, i:i+Window), 2);
    X = find(Y == 0);
    NumNeurons(count) = r - length(X); 
    count = count + 1;
end

%Plot number of neurons active in each Window
figure; plot(NumNeurons, 'o'); ylabel('Number of active neurons in window', 'FontSize', 15); xlabel('Window number', 'FontSize', 15);
ylim([0 max(NumNeurons)+ 5]);

%Get a histogram of the number of active neurons 
figure; histogram(NumNeurons); 
ylabel('Counts', 'FontSize', 15); xlabel('Num neurons', 'FontSize', 15);

