%PspontExponentLoop
%Marches through different values of Pspont, then extracts avalanche
%duration (alpha) and avalanche size (tau) exponents. It then plots these
%exponents in the alpha, tau plane. 

tic; 
iterations = 100000;
Layers = 14;
P = 0.5;
Ps = [0, 0.00005, 0.0001, 0.0005, 0.001];
Alpha_total = [];
Tau_total = [];
Gamma_total = [];
for i = 1:length(Ps)
        
        [TIMERASTER] = BranchingProcessFunction(Layers, P*2, iterations, Ps(i));
        [sizeDist, durationDist, SvsT, Events] = AvalancheAnalysis(TIMERASTER);
        [CCS, CCD] = GetCCDFs(sizeDist, durationDist); 
        [alpha, tau, gamma_est, gamma_act, error] = ExponentRelation(CCS, CCD, SvsT, 1, 8);
        Alpha_total = [Alpha_total; alpha];
        Tau_total = [Tau_total; tau];
        Gamma_total = [Gamma_total; gamma_act];

end

%make plots
figure; plot(abs(Tau_total), abs(Alpha_total), 'ko'); ylabel('Alpha', 'FontSize', 15); xlabel('Tau', 'FontSize', 15);
ylim([0 2]); 
xlim([0 2]);

toc
