function [TIMERASTERsub] = subSampler(TIMERASTER, fraction)
%Takes a TIMERASTER with r rows (neurons) and creates a new raster,
%TIMERASTERsub with fraction neurons. Restriction: 0 < fraction <= r.

[r c] = size(TIMERASTER);
new_r = randperm(r);    %randomly permute the sequence of neurons
TIMERASTERsub = TIMERASTER(new_r(1:floor(fraction*r)), :); %now only take the first fraction of the neurons

